;eax -> irow
;ebx -> p_inrow_up
;ecx -> cuento columnas
;edx -> p_inrow_down
;esi -> p_inrow
;edi -> p_outrow
section .data
msg1: db 'White: %d', 10, 0 ; formato: string numero enter fin de string.
msg2: db 'Dark: %d', 10, 0;
msg3: db 'f(x)=  %f x + %f', 10, 0;


section .text

%include "macros.mac"

%define inn [ebp+8]
%define outt [ebp+12]
%define dataOut [ebp-4]
%define dataIn [ebp-8]
%define widthstep [ebp-12]
%define filas [ebp-16]
%define cols [ebp-20]
%define white [ebp-21]
%define dark [ebp-22]
%define valA [ebp-26]
%define valB [ebp-30]
%define valAxmm [ebp-46]
%define valBxmm [ebp-62]
%define val255xmm [ebp-78]
%define mascara [ebp-94]

global brillo
extern printf


brillo:
	convencionC 94

	mov esi, inn
	mov eax, [esi + 8]
	mov eax, [esi + 68]
	mov dataIn, eax
	mov eax, [esi + 72]
	mov widthstep, eax
	mov eax, [esi +  44]
	mov filas, eax
	mov eax, [esi + 40]
	mov cols, eax

	mov al, 255
	mov white, al
	xor eax, eax
	mov dark, al

	pxor xmm5, xmm5
	mov ax, 255
	pinsrw xmm5, ax, 2
	pinsrw xmm5, ax, 3
	pinsrw xmm5, ax, 6
	pinsrw xmm5, ax, 7

	pxor xmm6, xmm6
	mov eax, 3
	pinsrd xmm6, eax, 0
	pshufd xmm6, xmm6, 00000000b
	cvtdq2ps xmm6, xmm6

	pxor xmm4, xmm4
	mov ax, 255
	pinsrw xmm4, ax, 0
	pinsrw xmm4, ax, 4
	pshufhw xmm4, xmm4, 00000000b
	pshuflw xmm4, xmm4, 00000000b
	movdqu val255xmm, xmm4

	xor eax, eax
	
.filasBuscarWyD:
	push eax
	mul DWORD widthstep
	add eax, dataIn
	mov esi, eax; p_inrow
	xor ecx, ecx	

.colsBuscarWyD:
	movdqu xmm0, [esi]
	movdqu xmm1, xmm0
	
	pxor xmm7, xmm7
	punpcklbw xmm0, xmm7
	punpckhbw xmm1, xmm7; tengo 2 pixeles en cada xmm

	phaddw xmm0, xmm7
	phaddw xmm0, xmm7; en las dos primeras words tengo las sumatorias de cada pixel

	phaddw xmm1, xmm7
	phaddw xmm1, xmm7; en las dos primeras words tengo las sumatorias de cada pixel

	punpcklwd xmm0, xmm7;
	punpcklwd xmm1, xmm7;las paso a doubleword

	cvtdq2ps xmm0, xmm0
	cvtdq2ps xmm1, xmm1;los paso a flotante

	divps xmm0, xmm6;divido por tres
	divps xmm1, xmm6
	
	cvtps2dq xmm0, xmm0
	cvtps2dq xmm1, xmm1

	packusdw xmm0, xmm1; ahora estan los 4 promedios juntos, en forma de words
	movdqu xmm1, xmm0
	
	paddw xmm0, xmm5
	phminposuw xmm0, xmm0; FUNCION MENTIROSA PARA CALCULAR EL MINIMO!
	packuswb xmm0, xmm7
	xor eax, eax
	pinsrb xmm0, eax, 1
	movd eax, xmm0
	xor ebx, ebx
	mov bl, white
	cmp eax, ebx
	jge .noEsMin
	mov white, al
.noEsMin:
	movdqu xmm3, xmm4
	psubw xmm3, xmm1
	phminposuw xmm3, xmm3
	mov ax, 255
	pinsrw xmm7, ax, 0
	psubw xmm7, xmm3; ahora si tengo el maximo en words
	xor eax, eax
	pinsrw xmm7, ax, 1;limpio el resto de los bytes de la primera dword
	pxor xmm2, xmm2
	packuswb xmm7, xmm2
	movd eax, xmm7
	xor ebx, ebx
	mov bl, dark
	cmp eax, ebx
	jle .noEsMax
	mov dark, al
.noEsMax:
	add esi, 16
	add ecx, 4
	mov ebx, cols
	sub ebx, ecx
	cmp ebx, 0
	jg .colsBuscarWyD	
	pop eax
	inc eax
	cmp eax, filas
	jl .filasBuscarWyD
.tengoWyD:
	xor eax, eax
	mov al, white
	cmp eax, 0
	je .esCero
	;b = 255.0 / ((-dark/white)+1)
	finit
	mov eax, 255
	push eax
	fild dword [esp]; [255]
	pop eax
	fld1;[1,255]
	xor eax, eax
	mov al, dark
	push eax
	fild dword [esp];[dark, 1,255]
	pop eax
	fchs;[-dark,1]
	xor eax, eax
	mov al, white
	push eax
	fild dword [esp]; [white, -dark, 1,255]
	pop eax
	fdivp; [(-dark)/white, 1,255]
	faddp;[(-dark/white)+1,255]
	fdivp;[255/((-dark/white)+1)]
	fst dword valB
	;a = (-b)/white
	fchs;[-b]
	xor eax, eax
	mov al, white
	push eax
	fild dword [esp];[white, -b]
	pop eax
	fdivp; [(-b)/white]
	fst dword valA
	
	jmp .tengoAyB
.esCero:
	xor eax, eax
	mov valB, eax

	;a = 255.0/dark
	finit
	mov eax, 255
	push eax
	fild dword [esp];[255]
	pop eax
	xor eax, eax
	mov al, dark
	push eax
	fild dword [esp];[dark, 255]
	pop eax
	fdivp; [255/dark]
	fst dword valA
.tengoAyB:
	xor eax, eax
	mov al, white
	push eax
	push msg1
	call printf
	add esp, 8
	xor eax, eax
	mov al, dark
	push eax
	push msg2
	call printf
	add esp, 8
	sub esp, 8
	fld dword valB
	fstp qword [esp]
	sub esp, 8
	fld dword valA
	fstp qword [esp]
	push msg3
	call printf
	add esp, 20

	movss xmm1, valB
	pshufd xmm1, xmm1, 00000000b
	movdqu valBxmm, xmm1
	movss xmm0, valA
	pshufd xmm0, xmm0, 00000000b
	movdqu valAxmm, xmm0

	mov esi, inn
	mov edi, outt
	mov eax, [edi + 68]
	mov dataOut, eax
	xor eax, eax

.filasCalcular:
	push eax
	mul DWORD widthstep
	add eax, dataIn
	mov esi, eax; p_inrow
	mov eax, [esp]
	mul DWORD widthstep
	add eax, dataOut
	mov edi, eax; p_outrow
	xor ecx, ecx	
.colsCalcular:
	movdqu xmm2, [esi]
	movdqu xmm3, xmm2
	movdqu xmm4, xmm2
	movdqu xmm5, xmm4
	
	pxor xmm7, xmm7
	punpcklbw xmm2, xmm7
	punpckhbw xmm3, xmm7; tengo 2 pixeles en cada xmm

	phaddw xmm2, xmm7
	phaddw xmm2, xmm7; en las dos primeras words tengo las sumatorias de cada pixel

	phaddw xmm3, xmm7
	phaddw xmm3, xmm7; en las dos primeras words tengo las sumatorias de cada pixel

	punpcklwd xmm2, xmm7;
	punpcklwd xmm3, xmm7;las paso a doubleword

	cvtdq2ps xmm2, xmm2
	cvtdq2ps xmm3, xmm3;los paso a flotante

	divps xmm2, xmm6;divido por tres
	divps xmm3, xmm6
	
	cvtps2dq xmm2, xmm2
	cvtps2dq xmm3, xmm3;los paso a enteros

	packusdw xmm2, xmm3; junto los valores en un mismo registro
	pshufd xmm2, xmm2, 01011000b ; los acomodo para que queden juntos
	punpcklwd xmm2, xmm7; unpackeo así tengo los bv en dwords en un mismo registro
	
	pcmpeqd xmm7, xmm2; me fijo si hay algun bv igual a cero
	movdqu mascara, xmm7; me guardo la mascara
	mov eax, 0xFFFFFFFF
	pinsrd xmm3, eax, 0
	pshufd xmm3, xmm3, 00000000b ; armo una mascara con todos los bits en 1
	pxor xmm7, xmm3; invierto los bits de xmm7
	ptest xmm7, xmm3; con esto chequeo si son todos cero los bv
	jz .todosCero; si es asi, no necesito hacer ninguna cuenta
	pxor xmm7, xmm3
	por xmm2, xmm7; los bv distintos de cero se mantienen, los restantes toman un valor basura, ya que no los voy a precisar
	movdqu xmm3, xmm2; copio el bv
	
	cvtdq2ps xmm2, xmm2
	cvtdq2ps xmm3, xmm3;paso los valores a flotante nuevamente
	
	movdqu xmm0, valAxmm
	mulps xmm3, xmm0; a * bv
	movdqu xmm1, valBxmm
	addps xmm3, xmm1; (a*bv) + b: tengo los 4 bn

	movdqu xmm7, xmm4
	pxor xmm1, xmm1
	
	punpcklbw xmm4, xmm1; agarro los 2 primeros pixeles
	movdqu xmm5, xmm4
	punpcklwd xmm4, xmm1; tengo el primer pixel
	punpckhwd xmm5, xmm1; tengo el segundo pixel

	punpckhbw xmm7, xmm1; agarro los otros dos pixeles
	movdqu xmm0, xmm7
	punpcklwd xmm7, xmm1; tengo el tercer pixel
	punpckhwd xmm0, xmm1; tengo el cuarto pixel
	
	cvtdq2ps xmm4, xmm4
	cvtdq2ps xmm5, xmm5;paso los pixeles a flotante
	cvtdq2ps xmm7, xmm7
	cvtdq2ps xmm0, xmm0;paso los pixeles a flotante

	pshufd xmm1, xmm3, 00000000b ;bn del primer pixel en xmm1
	mulps xmm4, xmm1
	pshufd xmm1, xmm2, 00000000b ;bv del primer pixel en xmm0
	divps xmm4, xmm1;tengo cr, cg y cb del primer pixel

	pshufd xmm1, xmm3, 01010101b ;bn del segundo pixel en xmm1
	mulps xmm5, xmm1
	pshufd xmm1, xmm2, 01010101b ;bv del segundo pixel en xmm0
	divps xmm5, xmm1;tengo cr, cg y cb del segundo pixel

	pshufd xmm1, xmm3, 10101010b ;bn del tercer pixel en xmm1
	mulps xmm7, xmm1
	pshufd xmm1, xmm2, 10101010b ;bv del tercer pixel en xmm0
	divps xmm7, xmm1;tengo cr, cg y cb del tercer pixel

	pshufd xmm1, xmm3, 11111111b ;bn del cuarto pixel en xmm1
	mulps xmm0, xmm1
	pshufd xmm1, xmm2, 11111111b ;bv del cuarto pixel en xmm0
	divps xmm0, xmm1;tengo cr, cg y cb del cuarto pixel

	cvtps2dq xmm4, xmm4
	cvtps2dq xmm5, xmm5;paso los valores a enteros
	cvtps2dq xmm7, xmm7
	cvtps2dq xmm0, xmm0;paso los valores a enteros

	packusdw xmm4, xmm5; vuelvo a juntar los pixeles
	packusdw xmm7, xmm0; idem
	packuswb xmm4, xmm7; vuelvo a juntar todo
.todosCero:
	movdqu xmm0, mascara; cargo la mascara para saber que bv eran iguales a cero
	pxor xmm7, xmm7
	pblendvb xmm4, xmm7, xmm0; cargo ceros en los pixeles con bv=0

	movdqu [edi], xmm4; los cargo en la salida
	
	add esi, 16
	add edi, 16
	add ecx, 4
	mov ebx, cols
	sub ebx, ecx
	cmp ebx, 0
	jg .colsCalcular
	
	pop eax
	inc eax
	cmp eax, filas
	jl .filasCalcular	
	
.fin:
	mov eax, outt
	finConvencionC 94
	ret
