%include "macros.mac"

global removerCanales 

section .text

%define i ebp+8
%define o ebp+12
%define c ebp+16

%define mascara [ebp-16]
%define step [ebp-20]
%define filas [ebp-24]
%define columnas edx
%define stacksize 24

%define in esi
%define out edi

removerCanales: 
	convencionC stacksize
	
	;primero armo una mascara para filtrar la imagen
	;voy guardando el resultado en ebx
	mov esi,[c]
	xor ebx,ebx
.rojo:
	mov al,[esi+2]
	cmp al,0
	jz .verde
	mov bl,0xff
.verde:
	shl ebx,8
	mov al,[esi+1]
	cmp al,0
	jz .azul
	mov bl,0xff
.azul:
	shl ebx,8
	mov al,[esi]
	cmp al,0
	jz .sigo
	mov bl,0xff
.sigo:
	mov [ebp-16],ebx
	mov [ebp-12],ebx
	mov [ebp-8],ebx
	mov [ebp-4],ebx
	
	mov in,[i]
	mov out,[o]

	mov eax,[in+44]
	mov filas,eax

	mov columnas,[in+40]
	mov eax,columnas
	
	mov ebx,[in+72]
	shl eax,2
	sub ebx,eax
	mov step,ebx

	mov in,[in+68]
	mov out,[out+68]

	movups xmm7,mascara
.cicloFilas:
	mov ecx,columnas
	shr ecx,2 ;proceso de a 4 pixels a la vez!
	.cicloColumnas:
		movups xmm0,[in]
		pand xmm0,xmm7
		movups [out],xmm0
		add in,16
		add out,16
	loop .cicloColumnas
	mov ecx,columnas
	mov eax,columnas
	and eax,0xfffffffc
	sub ecx,eax
	cmp ecx,0
	jz .nofaltan
	mov ebx,mascara	
.faltan:
	mov eax,[in]
	and eax,ebx
	add in,4
	mov [out],eax
	add out,4
	loop .faltan
.nofaltan:
	mov ecx,step
	add in,ecx
	add out,ecx
	dec DWORD filas
	jnz .cicloFilas

	finConvencionC stacksize
	ret
