%include "macros.mac"

global greyscale 

section .data
mult: DD 0.3,0.59,0.11,0.0
clean_alpha: DD 0xffffffff, 0xffffffff, 0xffffffff, 0x00000000

section .text

%define i ebp+8
%define o ebp+12

%define rows ebp-4

greyscale:
	convencionC 4 

	mov esi,[i]
	mov edi,[o]	;traigo los punteros a las imagenes

	mov edx,[esi + 44] ;cantidad de filas a procesar
	mov [rows],edx

	mov edx,[esi + 40] ;cantidad de columnas a procesar

	mov ebx,[edi + 72] ;el step, le resto el largo de la columna
	sub ebx,edx

	mov esi,[esi + 68]
	mov edi,[edi + 68]	

	pxor xmm7,xmm7
	movups xmm6,[mult]
	movups xmm5,[clean_alpha]

ciclo_filas:
	mov ecx,edx ;en ecx la cantidad de columnas restantes acutales

	ciclo_columnas: ;proceso de a 1 pixel a la vez
		movups xmm0,[esi]
		punpcklbw xmm0,xmm7		;b -> w
		punpcklwd xmm0,xmm7		;w -> dw
		cvtdq2ps xmm0,xmm0

		mulps xmm0,xmm6			;multiplico por lo q corresponde

		pand  xmm0,xmm5			;limpio canal de alfa

		haddps xmm0,xmm7		
		haddps xmm0,xmm7		;queda r+g+b,0,0,0

		cvtps2dq xmm0,xmm0		;convierto a int
		;psrldq xmm0,4*32		;pongo el int en la posicion mas baja

		movd eax,xmm0			;pongo el valor q me interesa en eax, ya se q es menor q 255
		mov BYTE [edi],al

		inc edi
		add esi,4
	loop ciclo_columnas

	add edi,ebx ;le sumo el step
	
	dec DWORD [rows]
	jnz ciclo_filas
	
	finConvencionC 4 
	ret
