;eax -> irow
;ebx -> p_inrow_up
;ecx -> cuento columnas
;edx -> p_inrow_down
;esi -> p_inrow
;edi -> p_outrow

%include "macros.mac"

%define inn [ebp+8]
%define outt [ebp+12]
%define dataOut [ebp-4]
%define dataIn [ebp-8]
%define widthstep [ebp-12]
%define filas [ebp-16]
%define cols [ebp-20]

global rangeOperator

section .text

rangeOperator:
	convencionC 20
	mov esi, inn
	mov edi, outt
	mov eax, [esi + 8]
	mov eax, [edi + 8]
	mov eax, [esi + 68]
	mov dataIn, eax
	mov eax, [edi + 68]
	mov dataOut, eax
	mov eax, [esi + 72]
	mov widthstep, eax
	mov eax, [esi +  44]
	mov filas, eax
	mov eax, [esi + 40]
	mov cols, eax
	xor eax, eax
	
.cicloFilas:
	push eax
	mov esi, eax
	mov edx, eax
	mov edi, eax
	inc esi
	add edx, 2
	push edx
	inc edi
	mul DWORD widthstep
	add eax, dataIn
	mov ebx, eax; p_inrow_up
	mov eax, esi
	mul DWORD widthstep
	add eax, dataIn
	mov esi, eax; p_inrow
	pop edx
	mov eax, edx
	mul DWORD widthstep
	add eax, dataIn
	mov edx, eax; p_inrow_down
	push edx
	mov eax, edi
	mul DWORD widthstep
	add eax, dataOut
	mov edi, eax; p_outrow, y ya tengo los 4 punteros
	pop edx
	mov ecx, cols
	shr ecx, 1

.cicloCols:
	movdqu xmm0, [esi]
	movdqu xmm1, [ebx]
	movdqu xmm2, [edx]
	pmaxub xmm0, xmm1
	pmaxub xmm0, xmm2; en xmm0 tengo los maximos de cada columna
	pxor xmm3, xmm3
	pshufd xmm3, xmm0, 00110000b
	pxor xmm4, xmm4
	pshufd xmm4, xmm0, 00011000b
	pmaxub xmm3, xmm0
	pmaxub xmm3, xmm4; en xmm3 tengo los máximos totales

	movdqu xmm0, [esi]
	pminub xmm0, xmm1
	pminub xmm0, xmm2; en xmm0 tengo los maximos de cada columna
	pxor xmm4, xmm4
	pshufd xmm4, xmm0, 00110000b
	pxor xmm5, xmm5
	pshufd xmm5, xmm0, 00011000b
	pminub xmm4, xmm0
	pminub xmm4, xmm5; en xmm5 tengo los minimos totales
	
	psubusb xmm3, xmm4; maximos - minimos

	mov al, 10000000b
	
	pxor xmm0, xmm0
	pinsrb xmm0, al, 4
	pinsrb xmm0, al, 5
	pinsrb xmm0, al, 6
	pinsrb xmm0, al, 7
	pinsrb xmm0, al, 8
	pinsrb xmm0, al, 9
	pinsrb xmm0, al, 10
	pinsrb xmm0, al, 11
	
	movdqu xmm2, [edi]	
	pblendvb xmm2, xmm3, xmm0
	movdqu [edi], xmm2
	
	add esi, 8
	add edi, 8
	add edx, 8
	add ebx, 8

	dec ecx
	cmp ecx, 0
	jg .cicloCols
	
	pop eax
	inc eax
	mov ecx, filas
	sub ecx, 2
	cmp eax, ecx
	jl .cicloFilas

	mov eax, outt
	finConvencionC 20
	ret