#!/bin/bash

if [ $# -eq 0 ]; then
  echo "./videoshop.sh [origen]"
else
opcion=1
until [ $opcion -eq 0 ]; do
  echo "Bienvenido a Videoshop - Elija un Filtro para su video:"
  echo " "
  echo "1) Brillo"
  echo "2) Gauss con Coeficientes"
  echo "3) Gauss sin Coeficientes"
  echo "4) Escala de Grises"
  echo "5) Zoom con Interpolación"
  echo "6) Laplace"
  echo "7) Pixelizar"
  echo "8) Bordes con Range Operator"
  echo "9) Bordes con Sobel"
  echo "10) RGB to HSL - Modificar Saturación"
  echo "11) Eliminación de canales"
  echo "12) Intercambio de canales"
  

  echo "0) Salir"

  read opcion

  case $opcion in
        1) echo " "; echo "Elija la version: 1) C++ //  2) Assembly // 3) CUDA"; read opcion; case $opcion in 1) ./brilloVideo $1 &> /dev/null ;; 2) ./brilloVideoASM $1 &> /dev/null ;; 3) ./brilloVideoCUDA $1 &> /dev/null ;; esac;;
        2) echo " "; echo "Elija la version: 1) C++ //  2) Assembly // 3) CUDA"; read opcion; case $opcion in 1) ./gaussEscaladaVideo $1 &> /dev/null ;; 2) ./gaussEscaladaVideoASM $1 &> /dev/null ;; 3) ./gaussEscaladaVideoCUDA $1 &> /dev/null ;; esac;;
        3) echo " "; echo "Elija la version: 1) C++ //  2) Assembly // 3) CUDA"; read opcion; case $opcion in 1) ./gaussSimpleVideo $1 &> /dev/null ;; 2) ./gaussSimpleVideoASM $1 &> /dev/null;; 3) ./gaussSimpleVideoCUDA $1 &> /dev/null;; esac;;
        4) echo " "; echo "Elija la version: 1) C++ //  2) Assembly // 3) CUDA"; read opcion; case $opcion in 1) ./greyscaleVideo $1 &> /dev/null;; 2) ./greyscaleVideoASM $1 &> /dev/null;; 3) ./greyscaleVideoCUDA $1 &> /dev/null;; esac;;
        5) echo " "; echo "Elija la version: 1) C++ //  2) Assembly // 3) CUDA"; read opcion; case $opcion in 1) ./interpolacionVideo $1 &> /dev/null;; 2) ./interpolacionVideoASM $1 &> /dev/null;; 3) ./interpolacionVideoCUDA $1 &> /dev/null;; esac;;
        6) echo " "; echo "Elija la version: 1) C++ //  2) Assembly // 3) CUDA"; read opcion; case $opcion in 1) ./laplaceVideo $1 &> /dev/null;; 2) ./laplaceVideoASM $1 &> /dev/null;; 3) ./laplaceVideoCUDA $1 &> /dev/null;; esac;;
        7) echo " "; echo "Elija la version: 1) C++ //  2) Assembly // 3) CUDA"; read opcion; case $opcion in 1) ./pixelizarVideo $1 &> /dev/null;; 2) ./pixelizarVideoASM $1 &> /dev/null;; 3) ./pixelizarVideoCUDA $1 &> /dev/null;; esac;;
        8) echo " "; echo "Elija la version: 1) C++ //  2) Assembly // 3) CUDA"; read opcion; case $opcion in 1) ./rangeOperatorVideo $1 &> /dev/null;; 2) ./rangeOperatorVideoASM $1 &> /dev/null;; 3) ./rangeOperatorVideoCUDA $1 &> /dev/null;; esac;;
        9) echo "Elija la version: 1) C++ //  2) Assembly // 3) CUDA"; read opcion; case $opcion in 1)./sobelVideo $1 &> /dev/null;; 2) ./sobelVideoASM $1 &> /dev/null;; 3) ./sobelVideoCUDA $1 &> /dev/null;; esac;;
        10) echo "Ingrese el cambio deseado en la saturación: "; read sat; echo "Elija la version: 1) C++ //  2) CUDA"; read opcion; case $opcion in 1) ./rgbtohslVideo $1 $2 $sat &> /dev/null;; 2) ./rgbtohslVideoCUDA $1 $2 $sat &> /dev/null;; esac;;
        11) echo "Ingrese un dígito para cada canal en el orden rgb, donde 0 - Eliminar / 1 - No Eliminar (Ej: 011)"; read code; echo " "; echo "Elija la version: 1) C++ //  2) Assembly  // 3) CUDA"; read opcion; case $opcion in 1) ./eliminarcanalesVideo $1 $code &> /dev/null;; 2) ./eliminarcanalesVideoASM $1 $code &> /dev/null;; 3) ./eliminarcanalesVideoCUDA $1 $code &> /dev/null;; esac;;
        12) echo "Ingrese un digito para cada canal en el orden bgr, donde 0 - Asignar Canal Rojo / 1 - Asignar Canal Verde / 2 - Asignar Canal Azul (Ej: 112)"; read code; echo " "; echo "Elija la version: 1) C++ //  2) Assembly // 3) CUDA"; read opcion; case $opcion in 1) ./intercambiarVideo $1 $code &> /dev/null;; 2) ./intercambiarVideoASM $1 $code &> /dev/null;; 3) ./intercambiarVideoCUDA $1 $code &> /dev/null;; esac;;
  esac
done
fi
